/*  b_function_20.c */

/*
  bؿκˤwavեκ

  16bit	ƥ쥪  ץǡ

  f = \sum_{i=1}^n x_i^2  b-function  (s+1)(s+n/2) Ǥ.

  (1/4) (\sum_{i=1}^n \partial_i^2 ) f^{s+1} = (s+1) (s+n/2) f^s

  n = 3 Ȥ˽벻
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
				ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*4L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char b_function( int i, double a, double b, double s );


int main()
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;

  double s1 = -1.0;    /* bؿκ */
  double s2 = -1.5; 

  double a1 = 7.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 7.156;
  double a2 = 7.512;
  double b2 = 7.056;


  fp = fopen( "b_function_20.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 4 */
  for( i = 0; i < 176400*1; i++ ) {
    c = b_function( i, a1, b1, s1);
    fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*4; i++ ){
    c = b_function( i, a1, b1, s1 )
      + b_function( i, a2, b2, s2 );
    fwrite( &c, sizeof(c), 1, fp );	
  }
  fclose( fp );

  return 0 ;
}

unsigned char b_function( int i, double a, double b, double s)
{
  int n;
  unsigned char f = 0;
  int v = 3000;           /* Ȥ® */
    

  f = a * sin( s * (double)(i / 176400.0) * v ) 
    + b * cos( s * (double)(i / 176400.0) * v );

  return f;
}


/* b_function_20.c  end */
