/*  gen_g.c */

/*
  ưˤwavեκ

  16bit	ƥ쥪  G(391.99543598174927 Hz)
*/

#include	<stdio.h>
#include	<math.h>

/*	߼Ψ	*/
#define		PIE		3.1415926535897932


typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
	
  p->nDataBytes = 176400L*7L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char gen( int i , double a, double b);


int		main( int ac, char* av[])
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;


  double a1 = 0.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 0.156;
  double a2 = -5.077;
  double b2 = 5.536;
  double a3 = -10.00;
  double b3 = 8.025;
  double a4 = -3.386;
  double b4 = 0.833;
  double a5 = 1.735;
  double b5 = 3.246;


	
  fp = fopen( "gen_g.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 7 */
  for( i = 0; i < 176400*1; i++ ) {
	c = gen( i, a1, b1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = gen( i, a1, b1 )
	  + gen( i, a2, b2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*2; i < 176400*3; i++ ) {
	c = gen( i, a1, b1 )
	  + gen( i, a2, b2 ) 
	  + gen( i, a3, b3 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*3; i < 176400*4; i++ ){
	c = gen( i, a1, b1 )
	  + gen( i, a2, b2 )
	  + gen( i, a3, b3 ) 
	  + gen( i, a4, b4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*4; i < 176400*7; i++ ){
	c = gen( i, a1, b1 ) 
	  + gen( i, a2, b2 ) 
	  + gen( i, a3, b3 ) 
	  + gen( i, a4, b4 ) 
	  + gen( i, a5, b5 );
	fwrite( &c, sizeof(c), 1, fp );
  }

  fclose( fp );
	
  return 0 ;
}

unsigned char gen( int i , double a, double b)
{
  int  n;
  unsigned char f = 0;
  int v = 391.99543598174927 * 2;           /* Ȥ® */
  int l = 1;             /* Ĺ */

	

  f = a * sin( PIE * (double)(i / 176400.0) * v / l) 
	+ b * cos( PIE * (double)(i / 176400.0) * v / l);
	  
  return f;
}


/* end  gen_g.c  */
