/*  b_function_16.c */

/*
  bؿκˤwavեκ

  16bit	ƥ쥪  ץǡ


  15*z^3+15*x*y^3*z+15*y^5

  [[-1,1],[s+1,3],[3*s+2,1],[3*s+4,1],[5*s+3,1]
  ,[5*s+4,1],[5*s+6,1],[5*s+7,1],[9*s+5,1],[9*s+7,1],
  [9*s+8,1],[9*s+10,1],[9*s+11,1],[9*s+13,1]]




*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*15L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char b_function( int i, double a, double b, double s );


int main()
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;

  double s1 = -1.0000000;    /* bؿκ */
  double s2 = -0.6666667; 
  double s3 = -1.3333333;
  double s4 = -0.6000000;
  double s5 = -0.8000000;
  double s6 = -1.2000000;
  double s7 = -1.4000000;
  double s8 = -0.5555556;
  double s9 = -0.7777778;
  double s10 = -0.8888889;
  double s11 = -1.1111111;
  double s12 = -1.2222222;
  double s13 = -1.4444444;

  double a1 = 12.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 6.156;
  double a2 = -12.077;
  double b2 = 5.536;
  double a3 = -10.00;
  double b3 = 8.025;
  double a4 = -13.077;
  double b4 = 2.134;
  double a5 = -12.212;
  double b5 = -15.035;
  double a6 = 12.017;
  double b6 = -12.166;
  double a7 = 15.020;
  double b7 = -3.121;
  double a8 = 10.4136;
  double b8 = -6.3145;
  double a9 = 4.1561;
  double b9 = 10.1442;
  double a10 = 10.3534;
  double b10 = -5.3513;
  double a11 = 6.3213;
  double b11 = 10.3572;
  double a12 = -6.3674;
  double b12 = 3.34567; 
  double a13 = 6.4473;
  double b13 = -12.6474;
	
  fp = fopen( "b_function_16.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 15 */
  for( i = 0; i < 176400*1; i++ ) {
	c = b_function( i, a1, b1, s1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*2; i < 176400*3; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*3; i < 176400*4; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*4; i < 176400*5; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*5; i < 176400*6; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function(i, a6, b6, s6 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*6; i < 176400*7; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*7; i < 176400*8; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 ) 
	  + b_function( i, a8, b8, s8 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*8; i < 176400*9; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 ) 
	  + b_function( i, a8, b8, s8 ) 
	  + b_function( i, a9, b9, s9 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*9; i < 176400*10; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 ) 
	  + b_function( i, a8, b8, s8 ) 
	  + b_function( i, a9, b9, s9 ) 
	  + b_function( i, a10, b10, s10 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*10; i < 176400*11; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 ) 
	  + b_function( i, a8, b8, s8 ) 
	  + b_function( i, a9, b9, s9 ) 
	  + b_function( i, a10, b10, s10 ) 
	  + b_function( i, a11, b11, s11 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*11; i < 176400*12; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 ) 
	  + b_function( i, a8, b8, s8 ) 
	  + b_function( i, a9, b9, s9 ) 
	  + b_function( i, a10, b10, s10 ) 
	  + b_function( i, a11, b11, s11 ) 
	  + b_function( i, a12, b12, s12 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*12; i < 176400*15; i++ ) {
	c = b_function( i, a1, b1, s1 ) 
	  + b_function( i, a2, b2, s2 ) 
	  + b_function( i, a3, b3, s3 ) 
	  + b_function( i, a4, b4, s4 ) 
	  + b_function( i, a5, b5, s5 ) 
	  + b_function( i, a6, b6, s6 ) 
	  + b_function( i, a7, b7, s7 ) 
	  + b_function( i, a8, b8, s8 ) 
	  + b_function( i, a9, b9, s9 ) 
	  + b_function( i, a10, b10, s10 ) 
	  + b_function( i, a11, b11, s11 ) 
	  + b_function( i, a12, b12, s12 ) 
	  + b_function( i, a13, b13, s13 );
	fwrite( &c, sizeof(c), 1, fp );	
  }

  fclose( fp );

  return 0 ;
}

unsigned char b_function( int i, double a, double b, double s)
{
  int n;
  unsigned char f = 0;
  int v = 5000;           /* Ȥ® */
    

  f = a * sin( s * (double)(i / 176400.0) * v ) 
	+ b * cos( s * (double)(i / 176400.0) * v );

  return f;
}


/* b_function_16.c  end */
