/*  b_function_2.c */

/*
  bؿκˤwavեκ

  16bit ƥ쥪  ץǡ

  -8*z^3+(144*x*y^2+24*x^4)*z-216*y^4-144*x^3*y^2-16*x^6

  [[1,1],[s+1,2],[3*s+2,1],[3*s+4,1],[4*s+3,1],
  [4*s+5,1],[6*s+5,1],[6*s+7,1]]

*/

#include    <stdio.h>
#include    <math.h>

typedef struct  tagWaveHeaderType   {
  char  cRiffHeader[4];
  long  nFileSize;
  char  cWaveHeader[4];
  char  cFmtChunk[4];
  long  nChunkSize;
  short nFmtID;
  short nCh;
  long  nRate;
  long  nSpeed;
  short nBlockSize;
  short nBitsParSample;
  char  cDataChunk[4];
  long  nDataBytes;
}   WaveHeaderType, * LpWaveHeaderType;


void    InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
    
  p->nFileSize = 0; /*  ե륵ʸǷ׻  */
    
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
    
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
    
  p->nChunkSize = 16;
    
  p->nFmtID = 1;    /*  ˥PCMʲϿ   */
    
  p->nCh = 2;       /*  ƥ쥪    */
  p->nRate = 44100; /*  ץ󥰼ȿ
                        ñ̻Υǡκμ    */
  p->nSpeed = 176400;   /*  ʿѥǡ®  */
  p->nBlockSize = 4;    /*  ֥å  */
  p->nBitsParSample = 16;   /*  ̻Ҳӥåȿ  */
    
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*9L;   /*  ǡ    */
    
  p->nFileSize = p->nDataBytes + 44L - 8L;  /*  ե륵  */
}

unsigned char b_function( int i, double a, double b, double s );


int main()
{
  WaveHeaderType    h;
  int       i, j;
  long  x;
  char  c;
  FILE* fp;

  double s1 = -1.0000;    /* bؿκ */
  double s2 = -0.6666; 
  double s3 = -1.3333;
  double s4 = -0.7500;
  double s5 = -1.2500;
  double s6 = -0.8333;
  double s7 = -1.1666;

  double a1 = 12.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 4.156;
  double a2 = -5.077;
  double b2 = 5.536;
  double a3 = -10.00;
  double b3 = 8.025;
  double a4 = -13.077;
  double b4 = 1.134;
  double a5 = -12.212;
  double b5 = -5.035;
  double a6 = 4.017;
  double b6 = -4.166;
  double a7 = 3.020;
  double b7 = -2.121;

  fp = fopen( "b_function_2.wav", "wb" );
    
  InitHeader( &h );
    
  fwrite( &h, sizeof(h), 1, fp );
    

  /* 9 */
  for( i = 0; i < 176400*1; i++ ) {
    c = b_function( i, a1, b1, s1);
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  for (i = 176400*1; i < 176400*2; i++ ){
    c = b_function( i, a1, b1, s1 ) 
      + b_function( i, a2, b2, s2 );
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  for( i = 176400*2; i < 176400*3; i++ ) {
    c = b_function( i, a1, b1, s1 ) 
      + b_function( i, a2, b2, s2 )
      + b_function( i, a3, b3, s3 );
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  for( i = 176400*3; i < 176400*4; i++ ) {
    c = b_function( i, a1, b1, s1 ) 
      + b_function( i, a2, b2, s2 ) 
      + b_function( i, a3, b3, s3 ) 
      + b_function( i, a4, b4, s4 );
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  for( i = 176400*4; i < 176400*5; i++ ) {
    c = b_function( i, a1, b1, s1 ) 
      + b_function( i, a2, b2, s2 ) 
      + b_function( i, a3, b3, s3 ) 
      + b_function( i, a4, b4, s4 ) 
      + b_function( i, a5, b5, s5 );
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  for( i = 176400*5; i < 176400*6; i++ ) {
    c = b_function( i, a1, b1, s1 ) 
      + b_function( i, a2, b2, s2 ) 
      + b_function( i, a3, b3, s3 ) 
      + b_function( i, a4, b4, s4 ) 
      + b_function( i, a5, b5, s5 ) 
      + b_function(i, a6, b6, s6 );
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  for( i = 176400*6; i < 176400*9; i++ ) {
    c = b_function( i, a1, b1, s1 ) 
      + b_function( i, a2, b2, s2 ) 
      + b_function( i, a3, b3, s3 ) 
      + b_function( i, a4, b4, s4 ) 
      + b_function( i, a5, b5, s5 ) 
      + b_function( i, a6, b6, s6 ) 
      + b_function( i, a7, b7, s7 );
    fwrite( &c, sizeof(c), 1, fp ); 
  }
  fclose( fp );

  return 0 ;
}

unsigned char b_function( int i, double a, double b, double s)
{
  int n;
  unsigned char f = 0;
  int v = 5000;           /* Ȥ® */
    

  f = a * sin( s * (double)(i / 176400.0) * v ) 
    + b * cos( s * (double)(i / 176400.0) * v );

  return f;
}


/* b_function_2.c  end */
